"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContributionRewardExtPlugin = void 0;
var graphql_tag_1 = __importDefault(require("graphql-tag"));
var index_1 = require("../../index");
var ContributionRewardExtPlugin = /** @class */ (function (_super) {
    __extends(ContributionRewardExtPlugin, _super);
    function ContributionRewardExtPlugin() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ContributionRewardExtPlugin.initializeParamsMap = function (initParams) {
        Object.keys(initParams).forEach(function (key) {
            if (initParams[key] === undefined) {
                throw new Error("ContributionRewardExt's initialize parameter '" + key + "' cannot be undefined");
            }
        });
        return [
            initParams.daoId,
            initParams.votingMachine,
            initParams.votingParams,
            initParams.voteOnBehalf,
            initParams.voteParamsHash,
            initParams.daoFactory,
            initParams.packageVersion,
            initParams.rewarderName
        ];
    };
    ContributionRewardExtPlugin.itemMap = function (context, item, queriedId) {
        if (!item) {
            index_1.Logger.debug("ContributionRewardExtPlugin ItemMap failed. " + (queriedId ? "Could not find ContributionRewardExtPlugin with id '" + queriedId + "'" : ''));
            return null;
        }
        if (!item.contributionRewardExtParams) {
            throw new Error("Plugin " + (queriedId ? "with id '" + queriedId + "'" : '') + "wrongly instantiated as ContributionRewardExt Plugin");
        }
        var baseState = index_1.Plugin.itemMapToBaseState(context, item);
        var contributionRewardExtParams = {
            rewarder: item.contributionRewardExtParams.rewarder,
            voteParams: index_1.mapGenesisProtocolParams(item.contributionRewardExtParams.voteParams),
            votingMachine: item.contributionRewardExtParams.votingMachine
        };
        return __assign(__assign({}, baseState), { pluginParams: contributionRewardExtParams });
    };
    ContributionRewardExtPlugin.prototype.createProposalTransaction = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!options.proposer) {
                            options.proposer = index_1.NULL_ADDRESS;
                        }
                        if (!!options.descriptionHash) return [3 /*break*/, 2];
                        _a = options;
                        return [4 /*yield*/, this.context.saveIPFSData(options)];
                    case 1:
                        _a.descriptionHash = _b.sent();
                        _b.label = 2;
                    case 2: return [2 /*return*/, {
                            contract: this.context.getContract(options.plugin),
                            method: 'proposeContributionReward',
                            args: [
                                options.descriptionHash || '',
                                (options.reputationReward && options.reputationReward.toString()) || 0,
                                [
                                    (options.nativeTokenReward && options.nativeTokenReward.toString()) || 0,
                                    (options.ethReward && options.ethReward.toString()) || 0,
                                    (options.externalTokenReward && options.externalTokenReward.toString()) || 0
                                ],
                                options.externalTokenAddress || index_1.NULL_ADDRESS,
                                options.beneficiary,
                                options.proposer
                            ]
                        }];
                }
            });
        });
    };
    ContributionRewardExtPlugin.prototype.createProposalTransactionMap = function () {
        var _this = this;
        return function (receipt) {
            var args = index_1.getEventArgs(receipt, 'NewContributionProposal', 'ContributionRewardExt.createProposal');
            var proposalId = args[1];
            return new index_1.ContributionRewardExtProposal(_this.context, proposalId);
        };
    };
    ContributionRewardExtPlugin.prototype.ethBalance = function () {
        return __awaiter(this, void 0, void 0, function () {
            var state, contributionRewardExt, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!!this.coreState) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.fetchState()];
                    case 1:
                        state = _c.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        state = this.coreState;
                        _c.label = 3;
                    case 3:
                        contributionRewardExt = this.context.getContract(state.address);
                        _b = (_a = this.context).ethBalance;
                        return [4 /*yield*/, contributionRewardExt.vault()];
                    case 4: return [2 /*return*/, _b.apply(_a, [_c.sent()])];
                }
            });
        });
    };
    ContributionRewardExtPlugin.fragment = {
        name: 'ContributionRewardExtParams',
        fragment: graphql_tag_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n      fragment ContributionRewardExtParams on ControllerScheme {\n        contributionRewardExtParams {\n          id\n          votingMachine\n          voteParams {\n            id\n            queuedVoteRequiredPercentage\n            queuedVotePeriodLimit\n            boostedVotePeriodLimit\n            preBoostedVotePeriodLimit\n            thresholdConst\n            limitExponentValue\n            quietEndingPeriod\n            proposingRepReward\n            votersReputationLossRatio\n            minimumDaoBounty\n            daoBountyConst\n            activationTime\n            voteOnBehalf\n          }\n          rewarder\n        }\n      }\n    "], ["\n      fragment ContributionRewardExtParams on ControllerScheme {\n        contributionRewardExtParams {\n          id\n          votingMachine\n          voteParams {\n            id\n            queuedVoteRequiredPercentage\n            queuedVotePeriodLimit\n            boostedVotePeriodLimit\n            preBoostedVotePeriodLimit\n            thresholdConst\n            limitExponentValue\n            quietEndingPeriod\n            proposingRepReward\n            votersReputationLossRatio\n            minimumDaoBounty\n            daoBountyConst\n            activationTime\n            voteOnBehalf\n          }\n          rewarder\n        }\n      }\n    "])))
    };
    return ContributionRewardExtPlugin;
}(index_1.ProposalPlugin));
exports.ContributionRewardExtPlugin = ContributionRewardExtPlugin;
var templateObject_1;
//# sourceMappingURL=plugin.js.map