import { Address, Arc, IGenesisProtocolParams, IPluginRegistrarProposalState, IPluginState, IProposalBaseCreateOptions, ITransaction, ITransactionReceipt, PluginRegistrarProposal, ProposalPlugin } from '../../index';
export interface IPluginRegistrarState extends IPluginState {
    pluginParams: {
        votingMachine: Address;
        voteRemoveParams: IGenesisProtocolParams;
        voteRegisterParams: IGenesisProtocolParams;
    };
}
export interface IInitParamsSR {
    daoId: string;
    votingMachine: string;
    votingParamsRegister: number[];
    voteOnBehalfRegister: string;
    voteRegisterParamsHash: string;
    votingParamsRemove: number[];
    voteOnBehalfRemove: string;
    voteRemoveParamsHash: string;
}
export interface IProposalCreateOptionsSR extends IProposalBaseCreateOptions {
    parametersHash?: string;
    permissions?: string;
    pluginToRegister?: Address;
}
export declare class PluginRegistrarPlugin extends ProposalPlugin<IPluginRegistrarState, IPluginRegistrarProposalState, IProposalCreateOptionsSR> {
    static fragment: {
        name: string;
        fragment: import("graphql").DocumentNode;
    };
    static initializeParamsMap(initParams: IInitParamsSR): (string | number[])[];
    static itemMap(arc: Arc, item: any, queriedId?: string): IPluginRegistrarState | null;
    createProposalTransaction(options: IProposalCreateOptionsSR): Promise<ITransaction>;
    createProposalTransactionMap(options: IProposalCreateOptionsSR): (receipt: ITransactionReceipt) => PluginRegistrarProposal;
}
